//		----------------------------------------------------------
//		-- fredrik olofsson 040226								--
//		-- converted from abstraction with the same name		--
//		-- updated for ub using xcode 070103					--
//		-- distributed under GNU GPL license					--
//		----------------------------------------------------------

#include "ext.h"
 
void *this_class;
 
typedef struct _f0ext {
	t_object x_ob;
	double x_valLeft;
	double x_valMiddle;
	double x_valRight;
	double x_valOut;
	void *x_out;
} x_f0ext;

void *f0ext_new(double value1, double value2);
void f0ext_int(x_f0ext *f0ext, long value);
void f0ext_float(x_f0ext *f0ext, double value);
void f0ext_ft1(x_f0ext *f0ext, double value);
void f0ext_ft2(x_f0ext *f0ext, double value);
void f0ext_bang(x_f0ext *f0ext);
void theFunction(x_f0ext *f0ext);
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst);

//----------------------------------------------------------------------------------------------
void main(void) {
	setup((Messlist **)&this_class, (method)f0ext_new, 0L, (short)sizeof(x_f0ext), 0L, A_DEFFLOAT, A_DEFFLOAT, 0);
	addbang((method)f0ext_bang);
	addint((method)f0ext_int);
	addfloat((method)f0ext_float);
	addftx((method)f0ext_ft1, 1);
	addftx((method)f0ext_ft2, 2);
	addmess((method)f0ext_assist, "assist", A_CANT, 0);
	finder_addclass("All Objects", "f0.frames_to_beats");
	finder_addclass("Math", "f0.frames_to_beats");
	post("f0.frames_to_beats v1.0.1-win; distributed under GNU GPL license");		//target specific
}
void *f0ext_new(double value1, double value2) {
	x_f0ext *f0ext;
	f0ext= (x_f0ext *)newobject(this_class);
	f0ext->x_valLeft= 0;
	f0ext->x_valOut= 0;
	if(value1==0&&value2==0) {
		f0ext->x_valMiddle= 120;
		f0ext->x_valRight= 20;
	} else if(value1!=0&&value2==0) {
		f0ext->x_valMiddle= value1;
		f0ext->x_valRight= 20;
	} else {
		f0ext->x_valMiddle= value1;
		f0ext->x_valRight= value2;
	}
	f0ext->x_out= floatout(f0ext);
	floatin(f0ext, 2);
	floatin(f0ext, 1);
	return(f0ext);
}
void f0ext_assist(x_f0ext *f0ext, void *box, long msg, long arg, char *dst) {
	if(msg==ASSIST_INLET) {
		switch(arg) {
			case 0:
				sprintf(dst, "frames (int/float)");
				break;
			case 1:
				sprintf(dst, "tempo bpm (float)");
				break;
			case 2:
				sprintf(dst, "fps (float)");
				break;
		}
	} else if(msg==ASSIST_OUTLET) {
		sprintf(dst, "beats (float)");
	}
}

//----------------------------------------------------------------------------------------------
void f0ext_int(x_f0ext *f0ext, long value) {
	f0ext->x_valLeft= value;
	theFunction(f0ext);
}
void f0ext_float(x_f0ext *f0ext, double value) {
	f0ext->x_valLeft= value;
	theFunction(f0ext);
}
void f0ext_ft1(x_f0ext *f0ext, double value) {
	f0ext->x_valMiddle= value;
}
void f0ext_ft2(x_f0ext *f0ext, double value) {
	f0ext->x_valRight= value;
}
void f0ext_bang(x_f0ext *f0ext) {
	outlet_float(f0ext->x_out, f0ext->x_valOut);
}

//----------------------------------------------------------------------------------------------
void theFunction(x_f0ext *f0ext) {
	if(f0ext->x_valMiddle==0||f0ext->x_valRight==0) {
		f0ext->x_valOut= 0;
	} else {
		f0ext->x_valOut= (f0ext->x_valLeft/f0ext->x_valRight)/(60/f0ext->x_valMiddle);
	}
	f0ext_bang(f0ext);
}
